require "blissful/rails/version"

module Blissful
  module Rails
    class << self
      # Loading the heavenly library
      def load!
        if rails?
          loader_for_rails
        elsif sprockets?
          loader_for_sprockets
        end
      end

      # Paths
      def gem_path
        @gem_path ||= File.expand_path '..', File.dirname(__FILE__)
      end

      def assets_path
        @assets_path ||= File.join gem_path, 'assets'
      end

      def javascripts_path
        File.join assets_path, 'javascripts'
      end

      # Environment detection helpers
      def rails?
        defined?(::Rails)
      end

      def sprockets?
        defined?(::Sprockets)
      end

      # Loader for Rails
      def loader_for_rails
        require 'blissful/rails/engine'
      end

      # Loader for Sprockets
      def loader_for_sprockets
        Sprockets.append_path(javascripts_path)
      end
    end
  end
end

Blissful::Rails.load!
